#include <stdio.h>
#include <stdlib.h>

#define StackSize 1000
#define ArraySize 1000

typedef char DataType;
typedef struct
{
    DataType data[StackSize];
    int top;
    int cnt;
} SeqStack;

SeqStack stack;

void InitStack(SeqStack *stack);
void ClearStack(SeqStack *stack);
int IsEmpty(SeqStack *stack);
int IsFull(SeqStack *stack);
void Push(SeqStack *stack, DataType data);
DataType Top(SeqStack *stack);
DataType Pop(SeqStack *stack);

void InitStack(SeqStack *stack)
{
    stack->top = 0; 
    stack->cnt = 0;
}

void ClearStack(SeqStack *stack)
{
    stack->top = 0; 
    stack->cnt = 0;
}

int IsEmpty(SeqStack *stack)
{
    return (stack->top == 0);
}

int IsFull(SeqStack *stack)
{
    return (stack->top == StackSize);
}

void Push(SeqStack *stack, DataType data)
{
    if (IsFull(stack)) { printf("overflow\n"); exit(-1); } 
    else { stack->data[stack->top++] = data; stack->cnt++; }
}

DataType Top(SeqStack *stack) {
    if (IsEmpty(stack)) { printf("underflow\n"); exit(-1); }
    else { return stack->data[stack->top-1]; }
}

DataType Pop(SeqStack *stack)
{
    DataType ret = Top(stack);
    stack->top--;
    stack->cnt--;
    return ret; 
}

int main()
{
    char ch, result[ArraySize];
    int i, cnt = 0;

    InitStack(&stack);			//初始化栈

    while ((ch = getchar()) != EOF)
    {
        if (ch == '#') break;	//编辑结束
        else if (ch == '*')		//清空栈
            ClearStack(&stack);
        else if (ch == '?')	Pop(&stack);	//出栈
        else Push(&stack, ch);	 		//入栈
    }

    while (!IsEmpty(&stack)) 
        result[cnt++] = Pop(&stack);

    for (i = cnt-1; i >= 0; i--) 
      printf("%c", result[i]);

    ClearStack(&stack);     //清空栈
}