#include <stdio.h>
#include <stdlib.h>

#define QueueSize 1000

typedef int DataType;
typedef struct
{
    DataType data[QueueSize];
    int front, rear, cnt;
} SeqQueue;

SeqQueue queue;

void InitQueue(SeqQueue *queue);
void ClearQueue(SeqQueue *queue);
int IsEmpty(SeqQueue *queue);
int IsFull(SeqQueue *queue);
void Enqueue(SeqQueue *queue, DataType data);
DataType Front(SeqQueue *queue);
DataType Dequeue(SeqQueue *queue);

void InitQueue(SeqQueue *queue)
{
    queue->front = queue->rear = 0;
    queue->cnt = 0;
}

void ClearQueue(SeqQueue *queue)
{
    queue->front = queue->rear = 0;
    queue->cnt = 0;
}

int IsEmpty(SeqQueue *queue)
{
    return (queue->front == queue->rear);
}

int IsFull(SeqQueue *queue)
{
    return (queue->rear == QueueSize);
}

void Enqueue(SeqQueue *queue, DataType data)
{
    if (IsFull(queue)) { printf("overflow\n"); exit(-1); }
    else { queue->data[queue->rear++] = data; queue->cnt++; }
}

DataType Front(SeqQueue *queue)
{
    if (IsEmpty(queue)) { printf("underflow\n"); exit(-1); }
    else { return queue->data[queue->front]; }
}

DataType Dequeue(SeqQueue *queue)
{
    DataType ret = Front(queue);
    queue->front++;
    queue->cnt--;
    return ret;
}

int main() {
    int n, m, i, t;
    DataType x;

    scanf("%d %d", &n, &m);

    InitQueue(&queue);

    for (i = 1; i <= n; i++) {
        scanf("%d", &t);
        Enqueue(&queue, t);
 
        while (!IsEmpty(&queue))
        {   //队头元素不在[t-m, t]范围内就出队 
            x = Front(&queue);
            if (x < t - m) Dequeue(&queue);
            else break;
        }

        printf("%d ", queue.cnt);
    }

    ClearQueue(&queue);
}